// copyright 2008 David Casperson
#if !defined(stopwatch_INCLUDED)

#include <iosfwd> // we don't need the full iostream here

class StopWatchImplementation ;

class StopWatch                 // The classic three button stop-watch
{
public:
    StopWatch() ;
    ~StopWatch() ;

    // The three buttons.
    StopWatch& start() ;  // second press does nothing
    StopWatch& stop() ;   // second press does nothing
    StopWatch& reset() ;  // leaves running watch running

    // and queries
    double elapsed() const ;
    bool is_running() const ;


private:
    StopWatchImplementation * it ;
} ;

std::ostream& operator<< (std::ostream& o, const StopWatch& s) ;

#define stopwatch_INCLUDED
#endif// !defined(stopwatch_INCLUDED)
